diff -U5 -ur nginx-0.8.7-orig/src/http/modules/ngx_http_proxy_module.c nginx-0.8.7/src/http/modules/ngx_http_proxy_module.c
--- nginx-0.8.7-orig/src/http/modules/ngx_http_proxy_module.c	2009-07-27 21:25:29.000000000 +0800
+++ nginx-0.8.7/src/http/modules/ngx_http_proxy_module.c	2009-08-10 13:39:21.000000000 +0800
@@ -164,10 +164,11 @@
     { ngx_string("invalid_header"), NGX_HTTP_UPSTREAM_FT_INVALID_HEADER },
     { ngx_string("http_500"), NGX_HTTP_UPSTREAM_FT_HTTP_500 },
     { ngx_string("http_502"), NGX_HTTP_UPSTREAM_FT_HTTP_502 },
     { ngx_string("http_503"), NGX_HTTP_UPSTREAM_FT_HTTP_503 },
     { ngx_string("http_504"), NGX_HTTP_UPSTREAM_FT_HTTP_504 },
+    { ngx_string("http_403"), NGX_HTTP_UPSTREAM_FT_HTTP_403 },
     { ngx_string("http_404"), NGX_HTTP_UPSTREAM_FT_HTTP_404 },
     { ngx_string("updating"), NGX_HTTP_UPSTREAM_FT_UPDATING },
     { ngx_string("off"), NGX_HTTP_UPSTREAM_FT_OFF },
     { ngx_null_string, 0 }
 };
diff -U5 -ur nginx-0.8.7-orig/src/http/ngx_http_upstream.c nginx-0.8.7/src/http/ngx_http_upstream.c
--- nginx-0.8.7-orig/src/http/ngx_http_upstream.c	2009-07-27 21:25:29.000000000 +0800
+++ nginx-0.8.7/src/http/ngx_http_upstream.c	2009-08-10 14:06:06.000000000 +0800
@@ -333,10 +333,11 @@
 static ngx_http_upstream_next_t  ngx_http_upstream_next_errors[] = {
     { 500, NGX_HTTP_UPSTREAM_FT_HTTP_500 },
     { 502, NGX_HTTP_UPSTREAM_FT_HTTP_502 },
     { 503, NGX_HTTP_UPSTREAM_FT_HTTP_503 },
     { 504, NGX_HTTP_UPSTREAM_FT_HTTP_504 },
+    { 403, NGX_HTTP_UPSTREAM_FT_HTTP_403 },
     { 404, NGX_HTTP_UPSTREAM_FT_HTTP_404 },
     { 0, 0 }
 };
 
 
@@ -2689,11 +2690,11 @@
 
 #if 0
     ngx_http_busy_unlock(u->conf->busy_lock, &u->busy_lock);
 #endif
 
-    if (ft_type == NGX_HTTP_UPSTREAM_FT_HTTP_404) {
+    if ((ft_type == NGX_HTTP_UPSTREAM_FT_HTTP_404) || (ft_type == NGX_HTTP_UPSTREAM_FT_HTTP_403)) {
         state = NGX_PEER_NEXT;
     } else {
         state = NGX_PEER_FAILED;
     }
 
@@ -2722,10 +2723,13 @@
 
         case NGX_HTTP_UPSTREAM_FT_HTTP_404:
             status = NGX_HTTP_NOT_FOUND;
             break;
 
+        case NGX_HTTP_UPSTREAM_FT_HTTP_403:
+            status = NGX_HTTP_FORBIDDEN;
+            break;
         /*
          * NGX_HTTP_UPSTREAM_FT_BUSY_LOCK and NGX_HTTP_UPSTREAM_FT_MAX_WAITING
          * never reach here
          */
 
diff -U5 -ur nginx-0.8.7-orig/src/http/ngx_http_upstream.h nginx-0.8.7/src/http/ngx_http_upstream.h
--- nginx-0.8.7-orig/src/http/ngx_http_upstream.h	2009-07-27 21:25:29.000000000 +0800
+++ nginx-0.8.7/src/http/ngx_http_upstream.h	2009-08-10 14:06:01.000000000 +0800
@@ -21,14 +21,15 @@
 #define NGX_HTTP_UPSTREAM_FT_INVALID_HEADER  0x00000008
 #define NGX_HTTP_UPSTREAM_FT_HTTP_500        0x00000010
 #define NGX_HTTP_UPSTREAM_FT_HTTP_502        0x00000020
 #define NGX_HTTP_UPSTREAM_FT_HTTP_503        0x00000040
 #define NGX_HTTP_UPSTREAM_FT_HTTP_504        0x00000080
-#define NGX_HTTP_UPSTREAM_FT_HTTP_404        0x00000100
-#define NGX_HTTP_UPSTREAM_FT_UPDATING        0x00000200
-#define NGX_HTTP_UPSTREAM_FT_BUSY_LOCK       0x00000400
-#define NGX_HTTP_UPSTREAM_FT_MAX_WAITING     0x00000800
+#define NGX_HTTP_UPSTREAM_FT_HTTP_403        0x00000100
+#define NGX_HTTP_UPSTREAM_FT_HTTP_404        0x00000200
+#define NGX_HTTP_UPSTREAM_FT_UPDATING        0x00000400
+#define NGX_HTTP_UPSTREAM_FT_BUSY_LOCK       0x00000800
+#define NGX_HTTP_UPSTREAM_FT_MAX_WAITING     0x00001000
 #define NGX_HTTP_UPSTREAM_FT_NOLIVE          0x40000000
 #define NGX_HTTP_UPSTREAM_FT_OFF             0x80000000
 
 #define NGX_HTTP_UPSTREAM_FT_STATUS          (NGX_HTTP_UPSTREAM_FT_HTTP_500  \
                                              |NGX_HTTP_UPSTREAM_FT_HTTP_502  \
